<template>
  <div :class="classBlock">
    <Renderer ref="renderer" antialias :width="sizes.width.toString()" :height="sizes.height.toString()" alpha>
      <PerspectiveCamera ref="camera" :position="{ z: 6 }" />
      <Scene ref="scene">
        <DirectionalLight color="#FFFFFF" :intensity="1" :position="{ x: 1, y:1, z:0 }"/>
        <Mesh ref="mesh1">
          <TorusGeometry :radialSegments="16" :tubularSegments="60"/>
        </Mesh>
        <Mesh ref="mesh2">
          <ConeGeometry :height="2" :radialSegments="32"/>
        </Mesh>
        <Mesh ref="mesh3">
          <TorusKnotGeometry :radius="0.8" :tube="0.35" :radialSegments="16" :tubularSegments="100"/>
        </Mesh>
      </Scene>
    </Renderer>
  </div>
</template>

<script>
  // -------------------------------------------- imports dependencies
  import { PerspectiveCamera, Renderer, Scene, DirectionalLight, TorusGeometry, Mesh, ConeGeometry, TorusKnotGeometry } from 'troisjs';
  import * as THREE from 'three'
  import { gsap } from 'gsap'

  export default {
    // -------------------------------------------- init
    name: 'Scene3D',
    // -------------------------------------------- imports components
    components: {PerspectiveCamera, Renderer, Scene, DirectionalLight, TorusGeometry, Mesh, ConeGeometry, TorusKnotGeometry},

    // -------------------------------------------- component properties
    props: {
      classNames: [] // string[],
    },

    // -------------------------------------------- components datas
    data: () => ({
      component: 'Scene3D',
      renderer: null,
      three: null,
      scene: null,
      camera: null,
      gradientTexture: null,
      objectsDistance: 4,
      scrollY: 0,
      materialColor: '#ffeded',
      currentSection: 0,
      sectionMeshes: []
    }),

    // -------------------------------------------- setup

    // -------------------------------------------- computed properties
    computed: {
      /**
      * class block formater
      */
      classBlock: function () {
        return [
          this.component,
          ...[this.classNames],
        ].filter(v => v).join(' ');
      },

      // get screen sizes
      sizes() {
        return {
          width: window.innerWidth,
          height: window.innerHeight
        }
      },

      // get material
      meshMaterial() {
        // Texture
        const textureLoader = new THREE.TextureLoader()
        const gradientTexture = textureLoader.load('../textures/gradients/3.jpg')
        gradientTexture.magFilter = THREE.NearestFilter

        // Material
        return new THREE.MeshToonMaterial({
            color: this.materialColor,
            gradientMap: gradientTexture
        })
      }
    },

    // -------------------------------------------- setup
    setup() {},

    // -------------------------------------------- mounted
    mounted() {
      // init datas threejs
      this.renderer = this.$refs.renderer
      this.three = this.renderer.three
      this.scene = this.three.scene
      this.camera = this.$refs.camera.camera

      // init app
      this.init()

      // launch scene
      this.sceneUpdater()
    },

    // -------------------------------------------- methods
    methods: {
      // main init
      init() {
        this.initScene()
        this.initEvents()
      },

      // init scene
      initScene() {
        this.initMeshMaterial()
        this.initMeshPositions()
        this.initParticules()
      },

      // init mesh positions
      initMeshPositions() {
        const mesh1 = this.$refs.mesh1.mesh
        const mesh2 = this.$refs.mesh2.mesh
        const mesh3 = this.$refs.mesh3.mesh

        mesh1.position.x = 2
        mesh2.position.x = - 2
        mesh3.position.x = 2

        mesh1.position.y = - this.objectsDistance * 0
        mesh2.position.y = - this.objectsDistance * 1
        mesh3.position.y = - this.objectsDistance * 2

        this.sectionMeshes = [mesh1, mesh2, mesh3]
      },

      // init mesh positions
      initMeshMaterial() {
        const mesh1 = this.$refs.mesh1.mesh
        const mesh2 = this.$refs.mesh2.mesh
        const mesh3 = this.$refs.mesh3.mesh

        mesh1.material = this.meshMaterial
        mesh2.material = this.meshMaterial
        mesh3.material = this.meshMaterial
      },

      // init particules
      initParticules() {
        const particlesCount = 200
        const positions = new Float32Array(particlesCount * 3)

        for(let i = 0; i < particlesCount; i++)
        {
            positions[i * 3 + 0] = (Math.random() - 0.5) * 10
            positions[i * 3 + 1] = this.objectsDistance * 0.5 - Math.random() * this.objectsDistance * 3
            positions[i * 3 + 2] = (Math.random() - 0.5) * 10
        }

        const particlesGeometry = new THREE.BufferGeometry()
        particlesGeometry.setAttribute('position', new THREE.BufferAttribute(positions, 3))

        // Material
        const particlesMaterial = new THREE.PointsMaterial({
            color: this.materialColor,
            sizeAttenuation: new THREE.TextureLoader(),
            size: 0.03
        })

        // Points
        const particles = new THREE.Points(particlesGeometry, particlesMaterial)
        this.scene.add(particles)
      },

      // init all Events
      initEvents() {
        window.addEventListener('scroll', this.scrollEvents)
      },

      // kill all Events
      killEvents() {
        window.removeEventListener('scroll', this.scrollEvents)
      },

      // scroll event
      scrollEvents(e) {
        this.scrollY = window.scrollY
        const newSection = Math.round(this.scrollY / this.sizes.height)

        if(newSection != this.currentSection)
        {
          this.currentSection = newSection

          gsap.to(
            this.sectionMeshes[this.currentSection].rotation,
            {
              duration: 1.5,
              ease: 'power2.inOut',
              x: '+=6',
              y: '+=3',
              z: '+=1.5'
            }
          )
        }
      },

      sceneUpdater() {
        // Animate camera
        this.camera.position.y = - this.scrollY / this.sizes.height * this.objectsDistance

        // Render
        this.renderer.render(this.scene, this.camera)

        // Call tick again on the next frame
        window.requestAnimationFrame(this.sceneUpdater)
      }
    },

    // -------------------------------------------- destroy / unmonted
    unmounted() {
      this.killEvents()
    }
  } 
</script>

<style lang="scss">
    // @import '../styles/reference';

    // Component name
    $COMPONENT: 'Scene3D';
    .Scene3D {
        // --------------------------------------------------------------------- CONFIG
        position: fixed;
        top: 0;
        left: 0;
        outline: none;
        // --------------------------------------------------------------------- BLOCK

        // --------------------------------------------------------------------- ELEMENTS

        // --------------------------------------------------------------------- MODIFIERS

        // --------------------------------------------------------------------- CHILDREN

        // --------------------------------------------------------------------- PSEUDOS

        // --------------------------------------------------------------------- PATCHES

    }

</style>

